/*
 * structs.cpp - cve-check-tool
 *
 * Copyright (C) 2015 Intel Corporation
 * Copyright (C) 2021 Aleksei Nikiforov <darktemplar@basealt.ru>
 *
 * cve-check-tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "structs.h"

#include <tuple>

bool cve_entry_t::operator==(const cve_entry_t &other) const
{
    return id == other.id;
}

bool cve_entry_t::operator<(const cve_entry_t &other) const
{
    return id < other.id;
}

binary_package_t::binary_package_t(const std::string &l_name, const std::string &l_version, const std::string &l_release)
    : name(l_name)
    , version(l_version)
    , release(l_release)
{
}

bool binary_package_t::operator<(const binary_package_t &other) const
{
    return std::tie(name, version, release) < std::tie(other.name, other.version, other.release);
}

bool issue_t::operator==(const issue_t &other) const
{
    return vulnerability_id == other.vulnerability_id;
}

bool issue_t::operator<(const issue_t &other) const
{
    return vulnerability_id < other.vulnerability_id;
}

bool discarded_issue_t::operator==(const discarded_issue_t &other) const
{
    return vulnerability_id == other.vulnerability_id;
}

bool discarded_issue_t::operator<(const discarded_issue_t &other) const
{
    return vulnerability_id < other.vulnerability_id;
}

bool source_package_base::operator==(const source_package_base &other) const
{
    return std::tie(murmur_hash, name, version, release)
        == std::tie(other.murmur_hash, other.name, other.version, other.release);
}

bool source_package_base::operator<(const source_package_base &other) const
{
    return std::tie(murmur_hash, name, version, release)
        < std::tie(other.murmur_hash, other.name, other.version, other.release);
}
