/*
 * parse-json.h - cve-check-tool
 *
 * Copyright (C) 2015 Intel Corporation
 * Copyright (C) 2021 Aleksei Nikiforov <darktemplar@basealt.ru>
 *
 * cve-check-tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#pragma once

#include <ctime>
#include <map>
#include <set>
#include <string>

#include "common.h"

struct vulnerability_record
{
    std::string description;
    std::string url;
    double score = 0.0;
    std::string attacktype;

    std::set<std::string> uris;

    std::time_t modifieddate = 0;

    std::set<cpe_info> cpe;

    std::string configurations;
    std::string type;
    actuality_status status = actuality_status::actual;

    bool operator==(const vulnerability_record &other) const;
};

void load_vulnerabilities_json(const std::string &fname, std::map<std::string, vulnerability_record> &vulnerabilities);
